import '../../resources/stylesheets/product-market.css';
import '../../resources/stylesheets/reset.css';

import React, { Component } from 'react'

export default class ProductMarket extends Component {
  constructor(props) {
    super(props)
    this.state = {}
  }

  componentDidMount() {
    this.props.getProducts();
    this.props.getPromotions();
  }

  calculateDiscount(price, discount) {
    return (price * (1.00 - discount / 100)).toFixed(2);
  }
  
  render() {
    let products = this.props.products;
    let promotions = this.props.promotions;
    
    products.forEach(prod => {
      promotions.forEach(promo => {
        if (prod.sku === promo.productSku) {
          prod.promo = (promo.discountPercentage * 100);
        }
      });
    });
    
    return (
      <div className="product-market-container">
        <h1 id="product-market-title">Product Market</h1>
        <div className="products-container">
          {this.props.products.map(prod => {
            return (
              <div className="product-item-container" key={ prod.sku }>
                { prod.productName ?
                  <div className="product-item">
                    <div id="more-details-img-box">
                      <img id="prod-img" src={ prod.productImageUrl ? prod.productImageUrl : "-no photo-" } />
                      <p id="more-details-text">More Details</p>
                    </div>
                    <p id="prod-name">{ prod.productName }</p>
                    <p id="prod-price">
                      { prod.promo ? 
                        <div id="promo-show">
                          <p id="promo-show-text-original">
                            ${ prod.price }
                          </p>
                          <p id="promo-show-text">
                            ${ this.calculateDiscount(prod.price, prod.promo) }
                          </p>
                        </div> : prod.price }
                    </p>
                    {prod.promo ?
                    <p id="prod-promotion">
                      { "Save " + prod.promo + "% on your order!"}
                    </p> : ""}
                    <button id="add-to-cart-button">Add to Cart</button>
                  </div>
                  : 
                  <div className="product-item">
                    <p id="prod-not-available">This Product is No Longer Available</p>
                  </div> }
              </div>
            )
          })}
        </div>
      </div>
    )
  }
}
